-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
-- edited by ihave3cats
local M = {}

local abs = math.abs
local relativeOdometer = 0
local submitedStatOdo = 0
local submitedTime = 0


local function number()
    local randomnumber2 = math.random(23500000,350000000)
    relativeOdometer = randomnumber2
    submitedStatOdo = randomnumber2
    submitedTime = randomnumber2
end

local function number2()
  local randomnumber2 = math.random(2350000,35000000)
  relativeOdometer = randomnumber2
  submitedStatOdo = randomnumber2
  submitedTime = randomnumber2
end

local function onReset()
  local choosennumber = math.random(1,8)
  print(choosennumber)
  if choosennumber == 1 or choosennumber == 2 or choosennumber == 3 or choosennumber == 4 then
    number()
  M.submitStatistic()
  end
  if choosennumber == 6 or choosennumber ==  7 or choosennumber == 8 or choosennumber == 5 then
    number2()
    M.submitStatistic()
  end
end

local function updateGFX(dt)
  relativeOdometer = relativeOdometer + abs(electrics.values.wheelspeed or 0) * dt
  submitedTime = submitedTime + dt
  if ai.mode == "disabled" and submitedTime > 30 then
    M.submitStatistic()
    submitedTime = 0
  end
end

local function startRecording()
  --relativeOdometer = 0
end

local function getRelativeRecording()
  return relativeOdometer
end

local function onExtensionLoaded()
end

local function submitStatistic()
  if ai.mode ~= "disabled" or (relativeOdometer - submitedStatOdo) < 1 then
    return
  end
  if ((relativeOdometer - submitedStatOdo) / submitedTime) > 150 then --550kph
    --log("I","sub","Too fast".. dumps((relativeOdometer-submitedStatOdo) / submitedTime))
    submitedStatOdo = relativeOdometer
    return
  end
  if isnan(relativeOdometer) then
    log("E", "odo", "fixed nan")
    relativeOdometer = submitedStatOdo
    return
  end
  local model = v.vehicleDirectory:match("/vehicles/([^/]+)")
  -- log("E","stat","m="..dumps(model).."\t"..dumps(relativeOdometer-submitedStatOdo))
  extensions.gameplayStatistic.metricAdd("vehicle/odometer/" .. model .. ".length", relativeOdometer - submitedStatOdo)
  extensions.gameplayStatistic.metricAdd("vehicle/total_odometer.length", relativeOdometer - submitedStatOdo)
  submitedStatOdo = relativeOdometer
end


-- public interface
M.onReset = onReset
M.updateGFX = updateGFX
M.startRecording = startRecording
M.getRelativeRecording = getRelativeRecording
M.submitStatistic = submitStatistic

M.onExtensionLoaded = onExtensionLoaded

return M
